//
//  ViewController.swift
//  OptimizationExtample
//
//  Created by Andrzej Naglik on 04.04.2017.
//  Copyright © 2017 Andrzej Naglik. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        let tap = UITapGestureRecognizer(target: self, action: #selector(self.tapped))
        self.view.addGestureRecognizer(tap)
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    @objc func tapped() {
        let result = self.funWithWords(["aaaaa", "bbbbbbbbb"])
        print(result)
    }
    
    fileprivate func funWithWords(_ words: [String]) -> [String] {        
        var resultArray = [String]()
        
        for index in 0..<words.count {
            // This will crash
            let pre = words[0...index].reduce("", +)
            resultArray.append(pre)
            
            // This version is ok
//            let pre = words[0...index].reduce("", +)
//            resultArray = resultArray + [pre]
            
            // This version is ok too
//            let pre = words[0...index].joined()
//            resultArray.append(pre)
            
            // This version is ok too
//            let pre = words[0...index]
//            let reduced = pre.reduce("", +)
//            resultArray.append(reduced)
            
        }
        
        return resultArray
    }
}

